"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScriptSourceHelper = void 0;
const nodes_1 = require("./nodes");
class ScriptSourceHelper {
    constructor(typescript, project) {
        this.typescript = typescript;
        this.project = project;
    }
    getNode(fileName, position) {
        const sourceFile = this.getSourceFile(fileName);
        return sourceFile && (0, nodes_1.findNode)(this.typescript, sourceFile, position);
    }
    getProgram() {
        return this.project.getLanguageService().getProgram();
    }
    getSourceFile(fileName) {
        const program = this.getProgram();
        return program ? program.getSourceFile(fileName) : undefined;
    }
}
exports.ScriptSourceHelper = ScriptSourceHelper;
//# sourceMappingURL=ScriptSourceHelper.js.map