"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findTemplateNodes = exports.findNode = void 0;
const ts = __importStar(require("typescript/lib/tsserverlibrary"));
function findNode(typescript, sourceFile, position) {
    function find(node) {
        if (position >= node.getStart() && position <= node.getEnd()) {
            return typescript.forEachChild(node, find) || node;
        }
    }
    return find(sourceFile);
}
exports.findNode = findNode;
function findTemplateNodes(typescript, sourceFile, tag) {
    const tags = [];
    function find(node) {
        if (node) {
            if (isTaggedTemplateExpression(node) && node.tag.getText() === tag) {
                tags.push(node);
            }
        }
        typescript.forEachChild(node, find);
    }
    find(sourceFile);
    return tags;
}
exports.findTemplateNodes = findTemplateNodes;
function isTaggedTemplateExpression(node) {
    return node.kind === ts.SyntaxKind.TaggedTemplateExpression;
}
//# sourceMappingURL=nodes.js.map